summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorRyan <fauxpark@gmail.com>2020-11-27 01:37:54 +1100
committerDrashna Jael're <drashna@live.com>2021-01-12 22:43:35 -0800
commit546a0e1edccaa7a53ae72c124f792783009b693b (patch)
tree7e75f4f4ded59293af0846c0132941654aa64551
parenta3b6a0c4d44db2a3aeecdfb71d8c5fb0ee740f09 (diff)
Refactor qmk_install.sh (#10681)
-rwxr-xr-xutil/freebsd_install.sh39
-rwxr-xr-xutil/install/arch.sh16
-rwxr-xr-xutil/install/debian.sh22
-rwxr-xr-xutil/install/fedora.sh15
-rwxr-xr-xutil/install/freebsd.sh18
-rwxr-xr-xutil/install/gentoo.sh33
-rwxr-xr-xutil/install/linux_shared.sh13
-rwxr-xr-xutil/install/macos.sh26
-rwxr-xr-xutil/install/msys2.sh36
-rwxr-xr-xutil/install/opensuse.sh31
-rwxr-xr-xutil/install/sabayon.sh15
-rwxr-xr-xutil/install/slackware.sh25
-rwxr-xr-xutil/install/solus.sh19
-rwxr-xr-xutil/install/void.sh15
-rwxr-xr-xutil/msys2_install.sh22
-rwxr-xr-xutil/qmk_install.sh93
16 files changed, 354 insertions, 84 deletions
diff --git a/util/freebsd_install.sh b/util/freebsd_install.sh
deleted file mode 100755
index f5c78b556f..0000000000
--- a/util/freebsd_install.sh
+++ /dev/null
@@ -1,39 +0,0 @@
-#!/bin/sh
-packages=$(cat <<EOF
- git \
- wget \
- gmake \
- gcc \
- zip \
- unzip \
- avr-binutils \
- avr-gcc \
- avr-libc \
- dfu-programmer \
- dfu-util \
- avrdude \
- arm-none-eabi-gcc \
- arm-none-eabi-binutils \
- arm-none-eabi-newlib \
- diffutils \
- python3
-EOF
-)
-util_dir=$(dirname "$0")
-if [ $(id -u) = 0 ]; then
- pkg update
- pkg install -y ${packages}
- echo ""
- echo "Re-run the setup as your normal user to install the qmk python dependencies"
- exit 1
-else
- if command -v sudo > /dev/null 2>&1; then
- sudo pkg update
- sudo pkg install -y ${packages}
- else
- echo "Make sure you run setup as root first to install base OS dependencies..."
- echo ""
- fi
-
- python3 -m pip install --user -r ${util_dir}/../requirements.txt
-fi
diff --git a/util/install/arch.sh b/util/install/arch.sh
new file mode 100755
index 0000000000..7442e2f136
--- /dev/null
+++ b/util/install/arch.sh
@@ -0,0 +1,16 @@
+#!/bin/bash
+
+_qmk_install() {
+ echo "Installing dependencies"
+
+ sudo pacman --needed --noconfirm -S \
+ base-devel clang diffutils gcc git unzip wget zip \
+ python-pip \
+ avr-binutils \
+ arm-none-eabi-binutils arm-none-eabi-gcc arm-none-eabi-newlib \
+ avrdude dfu-programmer dfu-util
+ sudo pacman --needed --noconfirm -U https://archive.archlinux.org/packages/a/avr-gcc/avr-gcc-8.3.0-1-x86_64.pkg.tar.xz
+ sudo pacman --needed --noconfirm -S avr-libc # Must be installed after the above, or it will bring in the latest avr-gcc instead
+
+ python3 -m pip install --user -r $QMK_FIRMWARE_DIR/requirements.txt
+}
diff --git a/util/install/debian.sh b/util/install/debian.sh
new file mode 100755
index 0000000000..e7180c6512
--- /dev/null
+++ b/util/install/debian.sh
@@ -0,0 +1,22 @@
+#!/bin/bash
+
+DEBIAN_FRONTEND=noninteractive
+DEBCONF_NONINTERACTIVE_SEEN=true
+export DEBIAN_FRONTEND DEBCONF_NONINTERACTIVE_SEEN
+
+_qmk_install_prepare() {
+ sudo apt-get update
+}
+
+_qmk_install() {
+ echo "Installing dependencies"
+
+ sudo apt-get -yq install \
+ build-essential clang-format diffutils gcc git unzip wget zip \
+ python3-pip \
+ binutils-avr gcc-avr avr-libc \
+ binutils-arm-none-eabi gcc-arm-none-eabi libnewlib-arm-none-eabi \
+ avrdude dfu-programmer dfu-util teensy-loader-cli
+
+ python3 -m pip install --user -r $QMK_FIRMWARE_DIR/requirements.txt
+}
diff --git a/util/install/fedora.sh b/util/install/fedora.sh
new file mode 100755
index 0000000000..250cda6624
--- /dev/null
+++ b/util/install/fedora.sh
@@ -0,0 +1,15 @@
+#!/bin/bash
+
+_qmk_install() {
+ echo "Installing dependencies"
+
+ # TODO: Check whether devel/headers packages are really needed
+ sudo dnf -y install \
+ clang diffutils git gcc glibc-headers kernel-devel kernel-headers make unzip wget zip \
+ python3 \
+ avr-binutils avr-gcc avr-libc \
+ arm-none-eabi-binutils-cs arm-none-eabi-gcc-cs arm-none-eabi-newlib \
+ avrdude dfu-programmer dfu-util
+
+ python3 -m pip install --user -r $QMK_FIRMWARE_DIR/requirements.txt
+}
diff --git a/util/install/freebsd.sh b/util/install/freebsd.sh
new file mode 100755
index 0000000000..353c52d647
--- /dev/null
+++ b/util/install/freebsd.sh
@@ -0,0 +1,18 @@
+#!/bin/bash
+
+_qmk_install_prepare() {
+ sudo pkg update
+}
+
+_qmk_install() {
+ echo "Installing dependencies"
+
+ sudo pkg install -y \
+ git wget gmake gcc zip unzip diffutils \
+ python3 \
+ avr-binutils avr-gcc avr-libc \
+ arm-none-eabi-binutils arm-none-eabi-gcc arm-none-eabi-newlib \
+ avrdude dfu-programmer dfu-util
+
+ sudo python3 -m pip install -r $QMK_FIRMWARE_DIR/requirements.txt
+}
diff --git a/util/install/gentoo.sh b/util/install/gentoo.sh
new file mode 100755
index 0000000000..d4284e9a93
--- /dev/null
+++ b/util/install/gentoo.sh
@@ -0,0 +1,33 @@
+#!/bin/bash
+
+_qmk_install_prepare() {
+ echo "This script will make a USE change in order to ensure that that QMK works on your system."
+ echo "All changes will be sent to the file /etc/portage/package.use/qmkfirmware -- please review it, and read Portage's output carefully before installing any packages on your system."
+ echo "You will also need to ensure that your kernel is compiled with support for the microcontroller that you are using (e.g. enable Arduino for the Pro Micro). Further information can be found on the Gentoo wiki."
+
+ read -p "Proceed? [y/N] " res
+ case $res in
+ [Yy]*)
+ return 0;;
+ *)
+ return 1;;
+ esac
+}
+
+_qmk_install() {
+ echo "Installing dependencies"
+
+ sudo touch /etc/portage/package.use/qmkfirmware
+ # tee is used here since sudo doesn't apply to >>
+ echo "sys-devel/gcc multilib" | sudo tee --append /etc/portage/package.use/qmkfirmware >/dev/null
+ sudo emerge -auN sys-devel/gcc
+ sudo emerge -au --noreplace \
+ app-arch/unzip app-arch/zip net-misc/wget sys-devel/clang sys-devel/crossdev \
+ \>=dev-lang/python-3.6 \
+ dev-embedded/avrdude dev-embedded/dfu-programmer app-mobilephone/dfu-util
+
+ sudo crossdev -s4 --stable --g \<9 --portage --verbose --target avr
+ sudo crossdev -s4 --stable --g \<9 --portage --verbose --target arm-none-eabi
+
+ python3 -m pip install --user -r $QMK_FIRMWARE_DIR/requirements.txt
+}
diff --git a/util/install/linux_shared.sh b/util/install/linux_shared.sh
new file mode 100755
index 0000000000..cb81e8611f
--- /dev/null
+++ b/util/install/linux_shared.sh
@@ -0,0 +1,13 @@
+#!/bin/bash
+
+# For those distros that do not package bootloadHID
+_qmk_install_bootloadhid() {
+ if ! command -v bootloadHID > /dev/null; then
+ wget https://www.obdev.at/downloads/vusb/bootloadHID.2012-12-08.tar.gz -O - | tar -xz -C /tmp
+ pushd /tmp/bootloadHID.2012-12-08/commandline/ > /dev/null
+ if make; then
+ sudo cp bootloadHID /usr/local/bin
+ fi
+ popd > /dev/null
+ fi
+}
diff --git a/util/install/macos.sh b/util/install/macos.sh
new file mode 100755
index 0000000000..93fda91215
--- /dev/null
+++ b/util/install/macos.sh
@@ -0,0 +1,26 @@
+#!/bin/bash
+
+_qmk_install_prepare() {
+ echo "Checking Homebrew installation"
+
+ if ! brew --version >/dev/null 2>&1; then
+ echo "Error! Homebrew is broken or not installed."
+ echo "Please run \`brew doctor\` or follow the installation instructions at https://brew.sh/, then re-run this script."
+ return 1
+ fi
+
+ brew update && brew upgrade
+}
+
+_qmk_install() {
+ echo "Installing dependencies"
+
+ # All macOS dependencies are managed in the Homebrew package:
+ # https://github.com/qmk/homebrew-qmk
+ brew install qmk/qmk/qmk
+
+ brew link --force avr-gcc@8
+ brew link --force arm-gcc-bin@8
+
+ python3 -m pip install -r $QMK_FIRMWARE_DIR/requirements.txt
+}
diff --git a/util/install/msys2.sh b/util/install/msys2.sh
new file mode 100755
index 0000000000..c8598a60fa
--- /dev/null
+++ b/util/install/msys2.sh
@@ -0,0 +1,36 @@
+#!/bin/bash
+
+_qmk_install_prepare() {
+ pacman -Syu
+}
+
+_qmk_install() {
+ echo "Installing dependencies"
+
+ pacman --needed --noconfirm --disable-download-timeout -S pactoys-git
+ pacboy sync --needed --noconfirm --disable-download-timeout \
+ base-devel: toolchain:x clang:x git: unzip: \
+ python3-pip:x \
+ avr-binutils:x avr-gcc:x avr-libc:x \
+ arm-none-eabi-binutils:x arm-none-eabi-gcc:x arm-none-eabi-newlib:x \
+ avrdude:x bootloadhid:x dfu-programmer:x dfu-util:x teensy-loader-cli:x
+
+ _qmk_install_drivers
+
+ python3 -m pip install -r "$QMK_FIRMWARE_DIR/requirements.txt"
+}
+
+_qmk_install_drivers() {
+ echo "Installing drivers"
+
+ tmpdir=$(mktemp -d)
+ cp "$QMK_FIRMWARE_UTIL_DIR/drivers.txt" $tmpdir
+ pushd $tmpdir > /dev/null
+
+ wget "https://github.com/qmk/qmk_driver_installer/releases/download/v1.01/qmk_driver_installer.exe"
+
+ cmd.exe //c "qmk_driver_installer.exe --all --force drivers.txt"
+
+ popd > /dev/null
+ rm -r $tmpdir
+}
diff --git a/util/install/opensuse.sh b/util/install/opensuse.sh
new file mode 100755
index 0000000000..47b44ae364
--- /dev/null
+++ b/util/install/opensuse.sh
@@ -0,0 +1,31 @@
+#!/bin/bash
+
+_qmk_install_prepare() {
+ case $(grep ID /etc/os-release) in
+ *15.1*)
+ REPO_RELEASE=Leap_15.1;;
+ *15.2*)
+ REPO_RELEASE=Leap_15.2;;
+ *)
+ #REPO_RELEASE=Tumbleweed;;
+ echo "ERROR: Tumbleweed is currently not supported."
+ exit 1
+ esac
+
+ sudo zypper addrepo https://download.opensuse.org/repositories/devel:gcc/openSUSE_$REPO_RELEASE/devel:gcc.repo
+ sudo zypper addrepo https://download.opensuse.org/repositories/hardware/openSUSE_$REPO_RELEASE/hardware.repo
+ sudo zypper --gpg-auto-import-keys refresh
+}
+
+_qmk_install() {
+ echo "Installing dependencies"
+
+ sudo zypper install -y \
+ make clang gcc unzip wget zip \
+ python3-pip \
+ cross-avr-binutils cross-avr-gcc8 avr-libc \
+ cross-arm-binutils cross-arm-none-gcc8 cross-arm-none-newlib-devel \
+ avrdude dfu-programmer dfu-util
+
+ python3 -m pip install --user -r $QMK_FIRMWARE_DIR/requirements.txt
+}
diff --git a/util/install/sabayon.sh b/util/install/sabayon.sh
new file mode 100755
index 0000000000..fd4f4d8dfd
--- /dev/null
+++ b/util/install/sabayon.sh
@@ -0,0 +1,15 @@
+#!/bin/bash
+
+_qmk_install() {
+ echo "Installing dependencies"
+
+ sudo equo install \
+ app-arch/unzip app-arch/zip net-misc/wget dev-vcs/git sys-devel/clang sys-devel/gcc sys-devel/crossdev \
+ dev-python/pip \
+ dev-embedded/avrdude dev-embedded/dfu-programmer app-mobilephone/dfu-util
+
+ sudo crossdev -s4 --stable --g \<9 --portage --verbose --target avr
+ sudo crossdev -s4 --stable --g \<9 --portage --verbose --target arm-none-eabi
+
+ python3 -m pip install --user -r $QMK_FIRMWARE_DIR/requirements.txt
+}
diff --git a/util/install/slackware.sh b/util/install/slackware.sh
new file mode 100755
index 0000000000..d73303159d
--- /dev/null
+++ b/util/install/slackware.sh
@@ -0,0 +1,25 @@
+#!/bin/bash
+
+_qmk_install_prepare() {
+ echo "Before you continue, please ensure that your user is added to sudoers and that sboinstall is configured."
+ read -p "Proceed? [y/N] " res
+
+ case $res in
+ [Yy]*)
+ ;;
+ *)
+ return 1;;
+ esac
+}
+
+_qmk_install() {
+ echo "Installing dependencies"
+
+ sudo sboinstall \
+ avr-binutils avr-gcc avr-libc \
+ arm-binutils arm-gcc newlib \
+ python3 \
+ avrdude dfu-programmer dfu-util teensy_loader_cli
+
+ python3 -m pip install --user -r $QMK_FIRMWARE_DIR/requirements.txt
+}
diff --git a/util/install/solus.sh b/util/install/solus.sh
new file mode 100755
index 0000000000..5633f7039c
--- /dev/null
+++ b/util/install/solus.sh
@@ -0,0 +1,19 @@
+#!/bin/bash
+
+_qmk_install_prepare() {
+ sudo eopkg -y update-repo
+ sudo eopkg -y upgrade
+}
+
+_qmk_install() {
+ echo "Installing dependencies"
+
+ sudo eopkg -y install \
+ -c system.devel git wget zip unzip \
+ python3 \
+ avr-binutils avr-gcc avr-libc \
+ arm-none-eabi-binutils arm-none-eabi-gcc arm-none-eabi-newlib \
+ avrdude dfu-programmer dfu-util
+
+ python3 -m pip install --user -r $QMK_FIRMWARE_DIR/requirements.txt
+}
diff --git a/util/install/void.sh b/util/install/void.sh
new file mode 100755
index 0000000000..9ec7019e5c
--- /dev/null
+++ b/util/install/void.sh
@@ -0,0 +1,15 @@
+#!/bin/bash
+
+_qmk_install() {
+ echo "Installing dependencies"
+
+ sudo xbps-install \
+ gcc git make wget unzip zip \
+ python3-pip \
+ avr-binutils avr-gcc avr-libc \
+ cross-arm-none-eabi-binutils cross-arm-none-eabi-gcc cross-arm-none-eabi-newlib \
+ avrdude dfu-programmer dfu-util teensy_loader_cli \
+ libusb-compat-devel
+
+ python3 -m pip install --user -r $QMK_FIRMWARE_DIR/requirements.txt
+}
diff --git a/util/msys2_install.sh b/util/msys2_install.sh
deleted file mode 100755
index 5abe4a597b..0000000000
--- a/util/msys2_install.sh
+++ /dev/null
@@ -1,22 +0,0 @@
-#!/bin/bash
-
-util_dir=$(dirname "$0")
-
-echo "Installing dependencies needed for the installation"
-pacman --needed --noconfirm --disable-download-timeout -Sy \
- base-devel mingw-w64-x86_64-toolchain mingw-w64-x86_64-clang git unzip \
- mingw-w64-x86_64-python-pip \
- mingw-w64-x86_64-avr-binutils mingw-w64-x86_64-avr-gcc mingw-w64-x86_64-avr-libc \
- mingw-w64-x86_64-arm-none-eabi-binutils mingw-w64-x86_64-arm-none-eabi-gcc mingw-w64-x86_64-arm-none-eabi-newlib \
- mingw-w64-x86_64-avrdude mingw-w64-x86_64-bootloadhid mingw-w64-x86_64-dfu-programmer mingw-w64-x86_64-dfu-util mingw-w64-x86_64-teensy-loader-cli
-
-echo "Installing drivers"
-tmpdir=$(mktemp -d)
-cp "${util_dir}/drivers.txt" $tmpdir
-pushd $tmpdir > /dev/null
-wget "https://github.com/qmk/qmk_driver_installer/releases/download/v1.01/qmk_driver_installer.exe"
-cmd.exe //c "qmk_driver_installer.exe --all --force drivers.txt"
-popd > /dev/null
-rm -r $tmpdir
-
-pip3 install -r "${util_dir}/../requirements.txt"
diff --git a/util/qmk_install.sh b/util/qmk_install.sh
index 714ee91445..5076e980a2 100755
--- a/util/qmk_install.sh
+++ b/util/qmk_install.sh
@@ -1,27 +1,74 @@
-#!/bin/sh
-# Pick the correct install script based on the current OS
+#!/bin/bash
-util_dir=$(dirname "$0")
+QMK_FIRMWARE_DIR=$(cd -P -- "$(dirname -- "$0")/.." && pwd -P)
+QMK_FIRMWARE_UTIL_DIR=$QMK_FIRMWARE_DIR/util
case $(uname -a) in
- *Darwin*)
- exec "${util_dir}/macos_install.sh"
- ;;
- *FreeBSD*)
- exec "${util_dir}/freebsd_install.sh"
- ;;
- *Linux*)
- exec "${util_dir}/linux_install.sh"
- ;;
- MINGW64_NT*)
- exec "${util_dir}/msys2_install.sh"
- ;;
- MSYS_NT*|MINGW32_NT*)
- echo "Please open a MinGW 64-bit terminal window and re-run this script."
- exit 1
- ;;
- *)
- echo "Environment not supported. Please see https://docs.qmk.fm for details on how to configure the QMK Firmware build tools manually."
- exit 1
- ;;
+ *Darwin*)
+ . "$QMK_FIRMWARE_UTIL_DIR/install/macos.sh";;
+ *FreeBSD*)
+ . "$QMK_FIRMWARE_UTIL_DIR/install/freebsd.sh";;
+ *MINGW64_NT*)
+ . "$QMK_FIRMWARE_UTIL_DIR/install/msys2.sh";;
+ *MSYS_NT*|*MINGW32_NT*)
+ echo "Please open a MinGW64 terminal window and re-run this script."
+ exit 1;;
+ *Linux*)
+ . "$QMK_FIRMWARE_UTIL_DIR/install/linux_shared.sh"
+
+ case $(grep ID /etc/os-release) in
+ *arch*|*manjaro*)
+ . "$QMK_FIRMWARE_UTIL_DIR/install/arch.sh";;
+ *debian*|*ubuntu*)
+ . "$QMK_FIRMWARE_UTIL_DIR/install/debian.sh";;
+ *fedora*)
+ . "$QMK_FIRMWARE_UTIL_DIR/install/fedora.sh";;
+ *gentoo*)
+ . "$QMK_FIRMWARE_UTIL_DIR/install/gentoo.sh";;
+ *opensuse*|*tumbleweed*)
+ . "$QMK_FIRMWARE_UTIL_DIR/install/opensuse.sh";;
+ *sabayon*)
+ . "$QMK_FIRMWARE_UTIL_DIR/install/sabayon.sh";;
+ *slackware*)
+ . "$QMK_FIRMWARE_UTIL_DIR/install/slackware.sh";;
+ *solus*)
+ . "$QMK_FIRMWARE_UTIL_DIR/install/solus.sh";;
+ *void*)
+ . "$QMK_FIRMWARE_UTIL_DIR/install/void.sh";;
+ *)
+ echo "Sorry, we don't recognize your distribution. Help us by contributing support!"
+ echo
+ echo "https://docs.qmk.fm/#/contributing"
+ exit 1;;
+ esac
+
+ if uname -a | grep -qi microsoft; then
+ echo "********************************************************************************"
+ echo "* Detected Windows Subsystem for Linux. *"
+ echo "* Currently, WSL has no access to USB devices and so flashing from within the *"
+ echo "* WSL terminal will not work. *"
+ echo "* *"
+ echo "* Please install the QMK Toolbox instead: *"
+ echo "* https://github.com/qmk/qmk_toolbox/releases *"
+ echo "* Then, map your WSL filesystem as a network drive: *"
+ echo "* \\\\\\\\wsl$\\<distro> *"
+ echo "********************************************************************************"
+ echo
+ fi
+ ;;
+ *)
+ echo "Sorry, we don't recognize your environment. Help us by contributing support!"
+ echo
+ echo "https://docs.qmk.fm/#/contributing"
+ exit 1;;
esac
+
+if type _qmk_install_prepare &>/dev/null; then
+ _qmk_install_prepare || exit 1
+fi
+
+_qmk_install
+
+if type _qmk_install_bootloadhid &>/dev/null; then
+ _qmk_install_bootloadhid
+fi